﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace EmployeeManagement.Entities
{
    public class Employee
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public byte Age { get; set; }
        public DateTime DateOfBirth { get; set; }

        private static List<Employee> _employees;
        private static int _id = 10000;

        static Employee()
        {
            _employees = new List<Employee>();
            Seed();
        }

        public static void Seed()
        {
            _employees.Add(new Employee() { Id = _id++, Name = "Liza", Age = 24, DateOfBirth = new DateTime(1993, 5, 22) });
            _employees.Add(new Employee() { Id = _id++, Name = "Macy", Age = 35, DateOfBirth = new DateTime(1982, 3, 7) });
            _employees.Add(new Employee() { Id = _id++, Name = "Joe", Age = 28, DateOfBirth = new DateTime(1989, 4, 10) });
            _employees.Add(new Employee() { Id = _id++, Name = "Max", Age = 19, DateOfBirth = new DateTime(1998, 11, 15) });
        }

        public static Employee Insert(Employee employee)
        {
            employee.Id = _id++;
            _employees.Add(employee);

            return employee;
        }

        public static Employee Select(int id)
        {
            return _employees.Where(e => e.Id == id).FirstOrDefault();
        }

        public static List<Employee> List()
        {
            return _employees;
        }

        public static void Update(Employee employee)
        {
            var currenctEmployee = _employees.Where(e => e.Id == employee.Id).FirstOrDefault();

            if (currenctEmployee is null)
                return;

            currenctEmployee.Name = employee.Name;
            currenctEmployee.Age = employee.Age;
            currenctEmployee.DateOfBirth = employee.DateOfBirth;
        }

        public static void Delete(int id)
        {
            _employees.RemoveAll(e => e.Id == id);
        }
    }
}
