﻿using EmployeeManagement.Business;
using EmployeeManagement.Entities;
using System;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace EmployeeManagement.Service.Controllers
{
    [RoutePrefix("api/employee")]
    public class EmployeeController : ApiController
    {
        [Route("")]
        [HttpPost]
        public HttpResponseMessage Create(Employee employee)
        {
            try
            {
                var bc = new EmployeeBusiness();
                var result = bc.Create(employee);

                return Request.CreateResponse(HttpStatusCode.Created, result);
            }
            catch (Exception ex)
            {
                return Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message);
            }
        }

        [Route("{id}")]
        [HttpGet]
        public HttpResponseMessage Get(int id)
        {
            try
            {
                var bc = new EmployeeBusiness();
                var result = bc.Get(id);

                return Request.CreateResponse(HttpStatusCode.OK, result);
            }
            catch (Exception ex)
            {
                return Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message);
            }
        }

        [Route("")]
        [HttpGet]
        public HttpResponseMessage List()
        {
            try
            {
                var bc = new EmployeeBusiness();
                var result = bc.List();

                return Request.CreateResponse(HttpStatusCode.OK, result);
            }
            catch (Exception ex)
            {
                return Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message);
            }
        }

        [Route("")]
        [HttpPut]
        public HttpResponseMessage Update(Employee employee)
        {
            try
            {
                var bc = new EmployeeBusiness();
                bc.Update(employee);

                return Request.CreateResponse(HttpStatusCode.Accepted);
            }
            catch (Exception ex)
            {
                return Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message);
            }
        }

        [Route("{id}")]
        [HttpDelete]
        public HttpResponseMessage Remove(int id)
        {
            try
            {
                var bc = new EmployeeBusiness();
                bc.Remove(id);

                return Request.CreateResponse(HttpStatusCode.Accepted);
            }
            catch (Exception ex)
            {
                return Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message);
            }
        }
    }
}
